Index: src/edu/ucsb/nceas/metacat/QuerySpecification.java
===================================================================
--- src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 691)
+++ src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 692)
@@ -54,7 +54,8 @@
  
   // Query data structures
   private String meta_file_id;
-  private String querytitle;
+// DOCTITLE attr cleared from the db
+//  private String querytitle;
   private Vector doctypeList;
   private Vector returnFieldList;
   private Vector ownerList;
@@ -265,8 +266,9 @@
     String currentTag = currentNode.getTagName();
     if (currentTag.equals("meta_file_id")) {
       meta_file_id = inputString;
-    } else if (currentTag.equals("querytitle")) {
-      querytitle = inputString;
+// DOCTITLE attr cleared from the db
+//    } else if (currentTag.equals("querytitle")) {
+//      querytitle = inputString;
     } else if (currentTag.equals("value")) {
       currentValue = inputString;
     } else if (currentTag.equals("pathexpr")) {
@@ -290,7 +292,7 @@
   public String printSQL() {
     StringBuffer self = new StringBuffer();
 
-    self.append("SELECT docid,docname,doctype,doctitle,");
+    self.append("SELECT docid,docname,doctype,");
     self.append("date_created, date_updated, rev ");
     self.append("FROM xml_documents WHERE docid IN (");
 
@@ -492,7 +494,7 @@
   {
     StringBuffer self = new StringBuffer();
 
-    self.append("SELECT docid,docname,doctype,doctitle,");
+    self.append("SELECT docid,docname,doctype,");
     self.append("date_created, date_updated ");
     self.append("FROM xml_documents WHERE docid IN (");
     self.append(docid).append(")");
@@ -504,8 +506,10 @@
    * This should become a way to get the XML serialization of the query.
    */
   public String toString() {
-    return "meta_file_id=" + meta_file_id + "\n" + 
-           "querytitle=" + querytitle + "\n" + query;
+    return "meta_file_id=" + meta_file_id + "\n" + query;
+//DOCTITLE attr cleared from the db
+//    return "meta_file_id=" + meta_file_id + "\n" + 
+//           "querytitle=" + querytitle + "\n" + query;
   }
 
   /** a utility class that represents a group of terms in a query */
Index: src/edu/ucsb/nceas/metacat/MetacatReplication.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 691)
+++ src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 692)
@@ -430,8 +430,10 @@
       sb.append("<documentinfo><docid>").append(docid);
       sb.append("</docid><docname>").append(doc.getDocname());
       sb.append("</docname><doctype>").append(doc.getDoctype());
-      sb.append("</doctype><doctitle>").append(doc.getDocTitle());
-      sb.append("</doctitle><user_owner>").append(doc.getUserowner());
+      sb.append("</doctype>");
+// DOCTITLE attr cleared from the db
+//      sb.append("</doctype><doctitle>").append(doc.getDocTitle());
+      sb.append("<user_owner>").append(doc.getUserowner());
       sb.append("</user_owner><user_updated>").append(doc.getUserupdated());
       sb.append("</user_updated><public_access>").append(doc.getPublicaccess());
       sb.append("</public_access><rev>").append(doc.getRev());
Index: src/edu/ucsb/nceas/metacat/DBQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 691)
+++ src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 692)
@@ -152,7 +152,8 @@
       String docid = null;
       String docname = null;
       String doctype = null;
-      String doctitle = null;
+// DOCTITLE attr cleared from the db
+//      String doctitle = null;
       String createDate = null;
       String updateDate = null;
       String fieldname = null;
@@ -194,10 +195,11 @@
           }
           docname = rs.getString(2);
           doctype = rs.getString(3);
-          doctitle = rs.getString(4);
-          createDate = rs.getString(5);
-          updateDate = rs.getString(6);
-          rev = rs.getInt(7);
+// DOCTITLE attr cleared from the db
+//          doctitle = rs.getString(4);
+          createDate = rs.getString(4);
+          updateDate = rs.getString(5);
+          rev = rs.getInt(6);
           
           //System.out.println("vec.size = " + returndocVec.size());
           if(returndocVec.size() != 0 && !returndocVec.contains(doctype))
@@ -244,7 +246,8 @@
               docid   = xmldoc.getDocID();
               docname = xmldoc.getDocname();
               doctype = xmldoc.getDoctype();
-              doctitle = xmldoc.getDocTitle();
+// DOCTITLE attr cleared from the db
+//              doctitle = xmldoc.getDocTitle();
               createDate = xmldoc.getCreateDate();
               updateDate = xmldoc.getUpdateDate();
               //System.out.println("docname: " + docname + " doctype: " + doctype + 
@@ -268,9 +271,10 @@
             if (doctype != null) {
               document.append("<doctype>" + doctype + "</doctype>");
             }
-            if (doctitle != null) {
-              document.append("<doctitle>" + doctitle + "</doctitle>");
-            }
+// DOCTITLE attr cleared from the db
+//            if (doctitle != null) {
+//              document.append("<doctitle>" + doctitle + "</doctitle>");
+//            }
             if(createDate != null) {
               document.append("<createdate>" + createDate + "</createdate>");
             }
@@ -492,16 +496,17 @@
       query.append("unspecified</meta_file_id>");
     }
     
-    query.append("<querytitle>");
-    if(params.containsKey("querytitle"))
-    {
-      query.append(((String[])params.get("querytitle"))[0]);
-      query.append("</querytitle>");
-    }
-    else
-    {
-      query.append("unspecified</querytitle>");
-    }
+// DOCTITLE attr cleared from the db
+//    query.append("<querytitle>");
+//    if(params.containsKey("querytitle"))
+//    {
+//      query.append(((String[])params.get("querytitle"))[0]);
+//      query.append("</querytitle>");
+//    }
+//    else
+//    {
+//      query.append("unspecified</querytitle>");
+//    }
     
     if(params.containsKey("doctype"))
     {
@@ -664,7 +669,8 @@
      xmlquery.append("<?xml version=\"1.0\"?>\n");
      xmlquery.append("<pathquery version=\"1.0\">");
      xmlquery.append("<meta_file_id>Unspecified</meta_file_id>");
-     xmlquery.append("<querytitle>Unspecified</querytitle>");
+// DOCTITLE attr cleared from the db
+//     xmlquery.append("<querytitle>Unspecified</querytitle>");
 
      if (!doctype.equals("any") && !doctype.equals("ANY")) {
        xmlquery.append("<returndoctype>");
Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 691)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 692)
@@ -523,13 +523,12 @@
         this.rootnodeid     = rs.getLong(3);
 // DOCTITLE attr cleared from the db
 //        this.doctitle       = rs.getString(4);
-        this.createdate     = rs.getString(5);
-        this.updatedate     = rs.getString(6);
-        this.userowner      = rs.getString(7);
-        this.userupdated    = rs.getString(8);
-        this.serverlocation = rs.getInt(9);
-        //this.publicaccess   = rs.getInt(10);
-        this.rev            = rs.getInt(10);
+        this.createdate     = rs.getString(4);
+        this.updatedate     = rs.getString(5);
+        this.userowner      = rs.getString(6);
+        this.userupdated    = rs.getString(7);
+        this.serverlocation = rs.getInt(8);
+        this.rev            = rs.getInt(9);
       } 
 
       if (this.doctype != null) {
@@ -1078,7 +1077,7 @@
       parser = XMLReaderFactory.createXMLReader(parserName);
 
       // Turn on validation
-      parser.setFeature("http://xml.org/sax/features/validation", false);
+      parser.setFeature("http://xml.org/sax/features/validation", true);
       // Turn off Including all external parameter entities
       // (the external DTD subset also)
       // Doesn't work well, probably the feature name is not correct