Index: test/stats/querydata.lst
===================================================================
--- test/stats/querydata.lst	(nonexistent)
+++ test/stats/querydata.lst	(revision 720)
@@ -0,0 +1,411 @@
+The SAS System                          03:31 Wednesday, February 28, 2001   1
+
+OBS    METHOD     NODES     DEPTH    QTIME    HITS    SEARCHED
+
+  1    index       11889      0       0.86      1            .
+  2    index       87054      0       2.86      1            .
+  3    index      162219      0       4.97      2            .
+  4    index     1428078      0      25.33     19      1428078
+  5    index     1503240      0      26.11     20      1503240
+  6    index     1578402      0      29.08     21      1578402
+  7    index     1653564      0      28.29     22      1653564
+  8    index     1728726      0      28.75     23      1728726
+  9    index     1803888      0      29.05     24      1803888
+ 10    index     1879050      0      29.03     25      1879050
+ 11    index     1954212      0      29.54     26      1954212
+ 12    index     2029374      0      31.72     27      2029374
+ 13    index       11889      1       0.53      1            .
+ 14    index       87054      1       0.52      1            .
+ 15    index      162219      1       0.53      2            .
+ 16    index     1428078      1       1.05     19          108
+ 17    index     1503240      1       1.10     20          108
+ 18    index     1578402      1       2.05     21          108
+ 19    index     1653564      1       1.60     22          108
+ 20    index     1728726      1       1.25     23          108
+ 21    index     1803888      1       1.84     24          108
+ 22    index     1879050      1       1.33     25          108
+ 23    index     1954212      1       1.74     26          108
+ 24    index     2029374      1       1.77     27          108
+ 25    index       11889      2       0.61      1            .
+ 26    index       87054      2       0.53      1            .
+ 27    index      162219      2       0.50      2            .
+ 28    index     1428078      2       0.71     19          108
+ 29    index     1503240      2       0.67     20          108
+ 30    index     1578402      2       1.14     21          108
+ 31    index     1653564      2       0.73     22          108
+ 32    index     1728726      2       0.73     23          108
+ 33    index     1803888      2       0.74     24          108
+ 34    index     1879050      2       0.78     25          108
+ 35    index     1954212      2       0.76     26          108
+ 36    index     2029374      2       0.78     27          108
+ 37    index       11889      3       0.54      1            .
+ 38    index       87054      3       0.50      1            .
+ 39    index      162219      3       0.54      2            .
+ 40    index     1428078      3       0.76     19           27
+ 41    index     1503240      3       0.80     20           27
+ 42    index     1578402      3       1.20     21           27
+ 43    index     1653564      3       0.73     22           27
+ 44    index     1728726      3       0.71     23           27
+ 45    index     1803888      3       0.73     24           27
+ 46    index     1879050      3       0.77     25           27
+ 47    index     1954212      3       0.73     26           27
+ 48    index     2029374      3       0.78     27           27
+ 49    index       11889      4       0.52      1            .
+ 50    index       87054      4       0.58      1            .
+ 51    index      162219      4       0.51      2            .
+ 52    index     1428078      4       0.74     19          189
+ 53    index     1503240      4       0.74     20          189
+ 54    index     1578402      4       1.34     21          189
+ 55    index     1653564      4       0.79     22          189
+ 56    index     1728726      4       0.78     23          189
+The SAS System                          03:31 Wednesday, February 28, 2001   2
+
+OBS    METHOD     NODES     DEPTH    QTIME    HITS    SEARCHED
+
+ 57    index     1803888      4       0.83     24          189
+ 58    index     1879050      4       0.89     25          189
+ 59    index     1954212      4       0.79     26          189
+ 60    index     2029374      4       0.91     27          189
+ 61    index       11889      5       0.63      1            .
+ 62    index       87054      5       0.68      1            .
+ 63    index      162219      5       0.86      2            .
+ 64    index     1428078      5      35.08     19        25083
+ 65    index     1503240      5      35.21     20        25083
+ 66    index     1578402      5      61.27     21        25083
+ 67    index     1653564      5      37.39     22        25083
+ 68    index     1728726      5      40.52     23        25083
+ 69    index     1803888      5      43.68     24        25083
+ 70    index     1879050      5      43.87     25        25083
+ 71    index     1954212      5      46.22     26        25083
+ 72    index     2029374      5      47.39     27        25083
+ 73    index       11889      6       0.60      1            .
+ 74    index       87054      6       0.51      1            .
+ 75    index      162219      6       0.54      2            .
+ 76    index     1428078      6       2.46     19          594
+ 77    index     1503240      6       2.68     20          594
+ 78    index     1578402      6       3.12     21          594
+ 79    index     1653564      6       2.71     22          594
+ 80    index     1728726      6       2.95     23          594
+ 81    index     1803888      6       3.09     24          594
+ 82    index     1879050      6       3.18     25          594
+ 83    index     1954212      6       3.20     26          594
+ 84    index     2029374      6       3.43     27          594
+ 85    nested      11889      0       0.73      1            .
+ 86    nested      87054      0       2.82      1            .
+ 87    nested     162219      0       5.02      2            .
+ 88    nested    1428078      0       8.40     19      1428078
+ 89    nested    1503240      0       8.17     20      1503240
+ 90    nested    1578402      0       8.57     21      1578402
+ 91    nested    1653564      0       7.50     22      1653564
+ 92    nested    1728726      0       7.75     23      1728726
+ 93    nested    1803888      0       8.29     24      1803888
+ 94    nested    1879050      0       9.17     25      1879050
+ 95    nested    1954212      0      22.48     26      1954212
+ 96    nested    2029374      0      28.67     27      2029374
+ 97    nested      11889      1       0.56      1            .
+ 98    nested      87054      1       0.49      1            .
+ 99    nested     162219      1       0.53      2            .
+100    nested    1428078      1       0.70     19          108
+101    nested    1503240      1       0.77     20          108
+102    nested    1578402      1       1.31     21          108
+103    nested    1653564      1       0.73     22          108
+104    nested    1728726      1       0.68     23          108
+105    nested    1803888      1       0.74     24          108
+106    nested    1879050      1       0.79     25          108
+107    nested    1954212      1       0.72     26          108
+108    nested    2029374      1       0.81     27          108
+109    nested      11889      2       0.62      1            .
+110    nested      87054      2       0.53      1            .
+111    nested     162219      2       0.50      2            .
+112    nested    1428078      2       0.65     19          108
+The SAS System                          03:31 Wednesday, February 28, 2001   3
+
+OBS    METHOD     NODES     DEPTH    QTIME    HITS    SEARCHED
+
+113    nested    1503240      2       0.92     20         108 
+114    nested    1578402      2       1.30     21         108 
+115    nested    1653564      2       0.79     22         108 
+116    nested    1728726      2       0.70     23         108 
+117    nested    1803888      2       0.80     24         108 
+118    nested    1879050      2       0.80     25         108 
+119    nested    1954212      2       0.78     26         108 
+120    nested    2029374      2       0.83     27         108 
+121    nested      11889      3       0.61      1           . 
+122    nested      87054      3       0.50      1           . 
+123    nested     162219      3       0.51      2           . 
+124    nested    1428078      3       0.68     19          27 
+125    nested    1503240      3       0.84     20          27 
+126    nested    1578402      3       1.17     21          27 
+127    nested    1653564      3       0.70     22          27 
+128    nested    1728726      3       0.70     23          27 
+129    nested    1803888      3       0.69     24          27 
+130    nested    1879050      3       0.74     25          27 
+131    nested    1954212      3       0.75     26          27 
+132    nested    2029374      3       0.72     27          27 
+133    nested      11889      4       0.59      1           . 
+134    nested      87054      4       0.53      1           . 
+135    nested     162219      4       0.51      2           . 
+136    nested    1428078      4       0.73     19         189 
+137    nested    1503240      4       0.85     20         189 
+138    nested    1578402      4       1.28     21         189 
+139    nested    1653564      4       0.85     22         189 
+140    nested    1728726      4       0.78     23         189 
+141    nested    1803888      4       0.77     24         189 
+142    nested    1879050      4       0.80     25         189 
+143    nested    1954212      4       0.82     26         189 
+144    nested    2029374      4       0.83     27         189 
+145    nested      11889      5       0.83      1           . 
+146    nested      87054      5       0.65      1           . 
+147    nested     162219      5       0.87      2           . 
+148    nested    1428078      5       7.77     19       25083 
+149    nested    1503240      5       8.36     20       25083 
+150    nested    1578402      5      12.09     21       25083 
+151    nested    1653564      5       8.47     22       25083 
+152    nested    1728726      5       8.70     23       25083 
+153    nested    1803888      5       8.84     24       25083 
+154    nested    1879050      5       8.96     25       25083 
+155    nested    1954212      5       9.71     26       25083 
+156    nested    2029374      5      10.84     27       25083 
+157    nested      11889      6       0.86      1           . 
+158    nested      87054      6       0.50      1           . 
+159    nested     162219      6       0.53      2           . 
+160    nested    1428078      6       0.74     19         594 
+161    nested    1503240      6       0.88     20         594 
+162    nested    1578402      6       1.22     21         594 
+163    nested    1653564      6       0.81     22         594 
+164    nested    1728726      6       0.81     23         594 
+165    nested    1803888      6       0.94     24         594 
+166    nested    1879050      6       0.84     25         594 
+167    nested    1954212      6       0.93     26         594 
+168    nested    2029374      6       0.86     27         594 
+The SAS System                          03:31 Wednesday, February 28, 2001   4
+
+General Linear Models Procedure
+Class Level Information
+
+Class    Levels    Values
+
+METHOD        2    index nested
+
+
+Number of observations in data set = 168
+
+
+NOTE: Due to missing values, only 126 observations can be used in this 
+      analysis.
+
+The SAS System                          03:31 Wednesday, February 28, 2001   5
+
+General Linear Models Procedure
+
+Dependent Variable: QTIME   
+                                    Sum of           Mean
+Source                  DF         Squares         Square   F Value     Pr > F
+
+Model                    4     7401.184408    1850.296102     16.99     0.0001
+
+Error                  121    13174.988939     108.884206
+
+Corrected Total        125    20576.173347
+
+                  R-Square            C.V.       Root MSE           QTIME Mean
+
+                  0.359697        139.8062       10.43476             7.463730
+
+
+Source                  DF       Type I SS    Mean Square   F Value     Pr > F
+
+METHOD                   1     1827.428750    1827.428750     16.78     0.0001
+NODES                    1       64.037530      64.037530      0.59     0.4446
+DEPTH                    1       14.490896      14.490896      0.13     0.7159
+SEARCHED                 1     5495.227232    5495.227232     50.47     0.0001
+
+Source                  DF     Type III SS    Mean Square   F Value     Pr > F
+
+METHOD                   1     1827.428750    1827.428750     16.78     0.0001
+NODES                    1       14.064335      14.064335      0.13     0.7199
+DEPTH                    1     1741.699812    1741.699812     16.00     0.0001
+SEARCHED                 1     5495.227232    5495.227232     50.47     0.0001
+
+
+
+The SAS System                          03:31 Wednesday, February 28, 2001   6
+
+           Plot of QTIME*DEPTH.  Legend: A = 1 obs, B = 2 obs, etc.
+
+QTIME |
+60.97 +                                                         A
+      |
+      |
+      |
+55.93 +
+      |
+      |
+      |
+50.89 +
+      |
+      |
+      |                                                         A
+45.85 +                                                         A
+      |
+      |                                                         B
+      |
+40.81 +                                                         A
+      |
+      |
+      |                                                         A
+35.77 +                                                         A
+      |                                                         A
+      |
+      |  A
+30.73 +
+      |  D
+      |  C
+      |
+25.69 +  B
+      |
+      |
+      |  A
+20.65 +
+      |
+      |
+      |
+15.61 +
+      |
+      |
+      |                                                         A
+10.57 +                                                         A
+      |  A                                                      D
+      |  F                                                      C
+      |
+ 5.53 +  B
+      |
+      |  B                                                                 I
+      |             H          B          B          B                     A
+ 0.49 +  B          P          V          V          V          F          N
+      ---+----------+----------+----------+----------+----------+----------+--
+         0          1          2          3          4          5          6
+
+                                        DEPTH
+
+                                                                              
+The SAS System                          03:31 Wednesday, February 28, 2001   7
+
+           Plot of QTIME*NODES.  Legend: A = 1 obs, B = 2 obs, etc.
+
+QTIME |
+60.97 +                                            A
+      |
+      |
+      |
+55.93 +
+      |
+      |
+      |
+50.89 +
+      |
+      |
+      |                                                         A
+45.85 +                                                       A
+      |
+      |                                                   A A
+      |
+40.81 +                                                A
+      |
+      |
+      |                                              A
+35.77 +                                          A
+      |                                        A
+      |
+      |                                                         A
+30.73 +
+      |                                            A      A A A
+      |                                              A A        A
+      |
+25.69 +                                        A A
+      |
+      |
+      |                                                       A
+20.65 +
+      |
+      |
+      |
+15.61 +
+      |
+      |
+      |                                            A
+10.57 +                                                         A
+      |                                                A  A B A
+      |                                        B B A B A  A
+      |
+ 5.53 +     B
+      |
+      |  B                                     A A A A A  A A A A
+      |                                            I A A  A A A A
+ 0.49 +N L  L                                  I I   H H  H H H H
+      -+-------------+-------------+-------------+-------------+-------------+
+       0          500000        1000000       1500000       2000000    2500000
+
+                                        NODES
+
+                                                                              
+The SAS System                          03:31 Wednesday, February 28, 2001   8
+
+         Plot of QTIME*SEARCHED.  Legend: A = 1 obs, B = 2 obs, etc.
+
+QTIME |
+60.97 + A
+      |
+      |
+      |
+55.93 +
+      |
+      |
+      |
+50.89 +
+      |
+      |
+      | A
+45.85 + A
+      |
+      | B
+      |
+40.81 + A
+      |
+      |
+      | A
+35.77 + A
+      | A
+      |
+      |                                                         A
+30.73 +
+      |                                            A      A A A
+      |                                              A A        A
+      |
+25.69 +                                        A A
+      |
+      |
+      |                                                       A
+20.65 +
+      |
+      |
+      |
+15.61 +
+      |
+      |
+      | A
+10.57 + A
+      | D                                                   A
+      | C                                      A A A A A  A
+      |
+ 5.53 +
+      |
+      |I
+      |O
+ 0.49 +Z
+      -+-------------+-------------+-------------+-------------+-------------+
+       0          500000        1000000       1500000       2000000    2500000
+
+                                      SEARCHED
+
+NOTE: 42 obs had missing values.  40 obs hidden.

Property changes on: test/stats/querydata.lst
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property